/*
 * Copyright (c) 2015-2016, Sumio Morioka
 * All rights reserved.
 *
 * This source code was originally written by Dr.Sumio Morioka for use in the 2015-2016 issues of 
 * "the Interface magazine", published by CQ publishing Co.Ltd in Japan (http://www.cqpub.co.jp).
 * The author has no responsibility on any results caused by using this code.
 *
 * - Author: Dr.Sumio Morioka (http://www002.upp.so-net.ne.jp/morioka, FB:Sumio Morioka)
 *
 *
 * IMPORTANT NOTICE:
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the copyright holder nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _WEBSOCKET_FUNC_H
#define _WEBSOCKET_FUNC_H

#include "websocket_flags.h"

//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
// BODY of global variables
//////////////////////////////////////////////////////////////////////////// <<

static int wsocket_callback_dumb_increment(struct libwebsocket_context *cntxt,
                                   struct libwebsocket *wsi,
                                   enum libwebsocket_callback_reasons reason,
                                   void *user,
                                   void *inp,
                                   size_t len)	// (main callback func)
{
//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
	switch (reason) {
	case LWS_CALLBACK_ESTABLISHED:
		send_serial16(0, 0x0000);	// stop

		fprintf(stderr, "websocket: connection established\n");
		break;

	case LWS_CALLBACK_RECEIVE:
		if (*((char *)inp) != '!') {	// NOT KEEP ALIVE MARK
			int	x, y;

			switch (*((char *)inp)) {
			case 'c':
				send_serial16(0, 0x0000);	// stop
				break;

			case 'u':
				send_serial16(0, 0x0000);	// stop
				send_serial16(1, 0);		// limit A
				send_serial16(2, 0);		// cnt A
				send_serial16(3, 0);		// limit B
				send_serial16(4, 0);		// cnt B

				send_serial16(0,
					   (1 & 0x0001)				// chA start
					+ ((0 << 1) & 0x0002)		// chA dir
					+ ((63 << 2) & 0x00FC)		// chA pwm
					+ ((1 << 8) & 0x0100)		// chB start
					+ ((0 << 9) & 0x0200)		// chB dir
					+ ((63 << 10) & 0xFC00)		// chB pwm
				);
//fprintf(stderr, "R %04X\n", receive_serial16(0));
				break;

			case 'd':
				send_serial16(0, 0x0000);	// stop
				send_serial16(1, 0);		// limit A
				send_serial16(2, 0);		// cnt A
				send_serial16(3, 0);		// limit B
				send_serial16(4, 0);		// cnt B

				send_serial16(0,
					   (1 & 0x0001)				// chA start
					+ ((1 << 1) & 0x0002)		// chA dir
					+ ((63 << 2) & 0x00FC)		// chA pwm
					+ ((1 << 8) & 0x0100)		// chB start
					+ ((1 << 9) & 0x0200)		// chB dir
					+ ((63 << 10) & 0xFC00)		// chB pwm
				);
//fprintf(stderr, "R %04X\n", receive_serial16(0));
				break;

			case 'l':
				send_serial16(0, 0x0000);	// stop
				send_serial16(1, 6);		// limit A
				send_serial16(2, 0);		// cnt A
				send_serial16(3, 6);		// limit B
				send_serial16(4, 0);		// cnt B

				send_serial16(0,
					   (1 & 0x0001)				// chA start
					+ ((0 << 1) & 0x0002)		// chA dir
					+ ((63 << 2) & 0x00FC)		// chA pwm
					+ ((1 << 8) & 0x0100)		// chB start
					+ ((1 << 9) & 0x0200)		// chB dir
					+ ((63 << 10) & 0xFC00)		// chB pwm
				);
//fprintf(stderr, "R %04X\n", receive_serial16(0));
				break;

			case 'r':
				send_serial16(0, 0x0000);	// stop
				send_serial16(1, 6);		// limit A
				send_serial16(2, 0);		// cnt A
				send_serial16(3, 6);		// limit B
				send_serial16(4, 0);		// cnt B

				send_serial16(0,
					   (1 & 0x0001)				// chA start
					+ ((1 << 1) & 0x0002)		// chA dir
					+ ((63 << 2) & 0x00FC)		// chA pwm
					+ ((1 << 8) & 0x0100)		// chB start
					+ ((0 << 9) & 0x0200)		// chB dir
					+ ((63 << 10) & 0xFC00)		// chB pwm
				);
//fprintf(stderr, "R %04X\n", receive_serial16(0));
				break;

			case 'i':
				sscanf((char *)inp, "i%d,%d", &x, &y);

				if (x >= 33 && x <= 66 && y < 33) {			// up
					send_serial16(0, 0x0000);	// stop
					send_serial16(1, 20);		// limit A
					send_serial16(2, 0);		// cnt A
					send_serial16(3, 20);		// limit B
					send_serial16(4, 0);		// cnt B

					send_serial16(0,
						   (1 & 0x0001)				// chA start
						+ ((0 << 1) & 0x0002)		// chA dir
						+ ((63 << 2) & 0x00FC)		// chA pwm
						+ ((1 << 8) & 0x0100)		// chB start
						+ ((0 << 9) & 0x0200)		// chB dir
						+ ((63 << 10) & 0xFC00)		// chB pwm
					);
				}
				else if (x >= 33 && x <= 66 && y > 66) {	// down
					send_serial16(0, 0x0000);	// stop
					send_serial16(1, 20);		// limit A
					send_serial16(2, 0);		// cnt A
					send_serial16(3, 20);		// limit B
					send_serial16(4, 0);		// cnt B

					send_serial16(0,
						   (1 & 0x0001)				// chA start
						+ ((1 << 1) & 0x0002)		// chA dir
						+ ((63 << 2) & 0x00FC)		// chA pwm
						+ ((1 << 8) & 0x0100)		// chB start
						+ ((1 << 9) & 0x0200)		// chB dir
						+ ((63 << 10) & 0xFC00)		// chB pwm
					);
				}
				else if (y >= 33 && y <= 66 && x < 33) {	// left
					send_serial16(0, 0x0000);	// stop
					send_serial16(1, 3);		// limit A
					send_serial16(2, 0);		// cnt A
					send_serial16(3, 3);		// limit B
					send_serial16(4, 0);		// cnt B

					send_serial16(0,
						   (1 & 0x0001)				// chA start
						+ ((0 << 1) & 0x0002)		// chA dir
						+ ((63 << 2) & 0x00FC)		// chA pwm
						+ ((1 << 8) & 0x0100)		// chB start
						+ ((1 << 9) & 0x0200)		// chB dir
						+ ((63 << 10) & 0xFC00)		// chB pwm
					);
				}
				else if (y >= 33 && y <= 66 && x > 66) {	// right
					send_serial16(0, 0x0000);	// stop
					send_serial16(1, 3);		// limit A
					send_serial16(2, 0);		// cnt A
					send_serial16(3, 3);		// limit B
					send_serial16(4, 0);		// cnt B

					send_serial16(0,
						   (1 & 0x0001)				// chA start
						+ ((1 << 1) & 0x0002)		// chA dir
						+ ((63 << 2) & 0x00FC)		// chA pwm
						+ ((1 << 8) & 0x0100)		// chB start
						+ ((0 << 9) & 0x0200)		// chB dir
						+ ((63 << 10) & 0xFC00)		// chB pwm
					);
				}
				else if (x >= 33 && x <= 66 && y >= 33 && y <= 66) {	// center
					send_serial16(0, 0x0000);	// stop
				}
				break;

			default:
				break;
			}
		}

		// send response TO AVOID TIMEOUT
		{
			unsigned char	buf	= '!';
			libwebsocket_write(wsi, &buf, 1, LWS_WRITE_TEXT);
		}
		break;

	case LWS_CALLBACK_CLOSED:
		send_serial16(0, 0x0000);	// stop

		fprintf(stderr, "websocket: connection closed\n");
		break;

	default:
		break;
    }

	return 0;
//////////////////////////////////////////////////////////////////////////// <<
}

#endif // _WEBSOCKET_FUNC_H

// end of file
